MSpeaklist <-
  function(
    savefilename = savefilename,
    pos = pos,
    fcnum = fcnum,
    MPeriod = MPeriod,
    MSthreshold = MSthreshold,
    lowestMSset = lowestMSset,
    highestMSset = highestMSset,
    MDFset =MDFset,
    MDFfilter = MDFfilter
  )
  {
    data.filename0 <- pos
    cont.scan.i <- 0
    deconv.num <- fcnum
    phase.shift = 0
    MSint.digits = 0
    
    if ( deconv.num != 0 ){
      for (r.fname in 1:deconv.num){
        fname <- paste("data.filename",r.fname,sep="")
        filename.paste <- paste("'",savefilename,"_layer", r.fname, ".cdf'",sep="")
        eval(parse(text=paste(fname, "<-", filename.paste,sep="") ))
      }
    } else {
      data.filename0 <- pos
    }
    
    for ( file.num in 0:deconv.num ){
      #20200604
      cdf.dat <- nc_open( eval(parse(text=paste("data.filename",file.num,sep="") )),write=TRUE )
      old.op <- options(max.print=9999999)
      flag <- ncvar_get(cdf.dat,"flag_count")
      scantime <- ncvar_get(cdf.dat,"scan_acquisition_time")
      #scannum <- ncvar_get(cdf.dat,"actual_scan_number")
      #medmsmax <- ncvar_get(cdf.dat,"mass_range_max")
      #medmsmin <- ncvar_get(cdf.dat,"mass_range_min")
      #ionid <- ncvar_get(cdf.dat,"scan_index")
      eachscannum <- ncvar_get(cdf.dat,"point_count")
      MStotint <- ncvar_get(cdf.dat,"total_intensity")
      MSvalue <- ncvar_get(cdf.dat,"mass_values")
      MSint <- round(ncvar_get(cdf.dat,"intensity_values"),digit=MSint.digits)
      #20200604
      
      Timepara <- scantime[which(abs(eachscannum)<.Machine$integer.max )]
      RTini <- min( Timepara )/60
      RTruntime <- max( Timepara )/60-RTini
      SamRate <- 1/(mean( Timepara[2:length(Timepara)]-Timepara[1: (length(Timepara)-1) ] ))
      
      
      pixelnum <- length(flag)
      maxscannum <- max(eachscannum)
      minscannum <- min(eachscannum)
      MSdatabox <- matrix(0,pixelnum, maxscannum+1 )
      MSvaluebox <- MSdatabox
      MSintbox <- MSdatabox
      
      for (inum in 1:pixelnum) {
        if (abs(eachscannum[inum])<.Machine$integer.max){
          initial <- sum(eachscannum[1:inum])-eachscannum[inum]+1
          acqrange <- initial:(initial+eachscannum[inum]-1)
          if(eachscannum[inum]==0){acqrange <-0}
          remainrep <- rep(0,maxscannum-eachscannum[inum]+1 )
          MSvaluebox[inum,] <- c( MSvalue[ acqrange ], remainrep )
          MSintbox[inum,] <- c( MSint[ acqrange ], remainrep )
        }}
      rownames(MSvaluebox) <-1:(pixelnum)
      rownames(MSintbox) <-1:(pixelnum)
      MSvaluebox[which(MSintbox > 9e+36)] <- -1
      MSintbox[which(MSintbox > 9e+36)] <- -1
      
      
      #Filter MSint Threshold
      MSintbox[which(MSintbox < MSthreshold)] <-0
      MSvaluebox[which(MSintbox < MSthreshold)] <-0
      
      #Filter MDF
      if ( MDFfilter==1){
        posnum <- which( (MSvaluebox - floor(MSvaluebox) )  <= 1 + MDFset )
        MSvaluebox[posnum] <- 0
        MSintbox[posnum] <-0
      }
      
      #Filter MSrange
      MSintbox[which(MSvaluebox <= lowestMSset)] <-0
      MSvaluebox[which(MSvaluebox <= lowestMSset)] <-0
      MSintbox[which(MSvaluebox >= highestMSset)] <-0
      MSvaluebox[which(MSvaluebox >= highestMSset)] <-0
      
      
      #2D TIC data matrix for picture
      originalmatrix <- seq(1, length(flag)) 
      blankbox2original <-  rep(0,length(flag)) 
      usualid <- 0
      
      row <- round(SamRate*MPeriod)
      col <- round(length(scantime)/row)
      
      redidu <- row-SamRate*MPeriod
      redidu.accum <- 1
      blank.id <- round(phase.shift*SamRate+1)
      cont.num <- 0
      tic.box <- as.matrix( rowSums(MSintbox)  )
      mat <- matrix(1,row,col)
      pixel.idbox <- mat
      
      try(silent =TRUE,for (u in round(phase.shift*SamRate+1):(length(tic.box[,1])+round(phase.shift*SamRate)) ){
        usualid <- usualid + 1
        #No correction for phase.shift, data lose
        #if ( u%%row==0 ){
        #redidu.accum <-redidu.accum + redidu
        #}
        if ( redidu.accum > 1 ){
          blank.id <- blank.id +1
          mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
          if ( blank.id > 0 ){
            blankbox2original[blank.id] <- originalmatrix[usualid]
          }
          blank.id <- blank.id +1
          mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
          if ( blank.id > 0 ){
            blankbox2original[blank.id] <- originalmatrix[usualid]
          }
          redidu.accum <- redidu.accum -1 
        } else {
          blank.id <- blank.id +1
          mat[row*ceiling(blank.id/row)-(blank.id-1),ceiling( (u-round(phase.shift*SamRate))/row )] <- tic.box[round(u-phase.shift*SamRate),]
          if (blank.id > 0){
            blankbox2original[blank.id] <- originalmatrix[usualid]
          }
        }
        
      })
      #2D TIC data matrix for picture
      
      #Graphics
      zz1 <- t(apply(as.matrix(mat[1:nrow(mat),1:ncol(mat)]),2,rev))
      xx1 <- (1:nrow(zz1))/col*RTruntime+RTini
      yy1 <-(((1:ncol(zz1))/row*MPeriod))
      max.zz<-max(zz1)
      
      #20200604 Exit, if invalid data
      if ( all(zz1==0|zz1==Inf|is.na(zz1)) ){
        return("Invalid data. All the data are '0' or 'Inf' or 'NA'.")
      }
      #20200604
      
      windows(width=10,height=5)
      par(mar=c(5,7,1,1))
      filled.contour(xx1,yy1,zz1,xlab="GC1 (min)",ylab="GC2 (sec)",col=terrain.colors(30),levels=seq(0,max(tic.box)+0.1,max(tic.box)/30+0.1) )
      
      #Combine three 2DTIC
      mat1 <- c(rep(0,row),mat[1:(length(mat)-row)])
      mat1 <- matrix(mat1,row,col)
      mat2 <- c(mat)
      mat2 <- matrix(mat2,row,col)
      mat3 <- c(mat[(row+1):length(mat)],rep(0,row))
      mat3 <- matrix(mat3,row,col)
      
      com.mat <- 0
      for (roop.col in 1:col){
        com.mat.new <- c(mat1[,roop.col],mat2[,roop.col],mat3[,roop.col])
        com.mat <- c(com.mat,com.mat.new)
      }
      
      com.mat <- com.mat[-c(1)]
      com.mat <- matrix(com.mat,3*row,col)
      com.watershed1 <- watershed(com.mat[1:nrow(com.mat),1:ncol(com.mat)], ext=ext.watershed)
      com.watershed2 <- com.watershed1
      
      for (wat.col.num in 1:(col-1) ){
        if (com.watershed1[2*row,wat.col.num]==com.watershed1[2*row+1,wat.col.num]){
          target.watid <- com.watershed1[1*row+1,wat.col.num+1]
          mod.watid <- com.watershed1[2*row,wat.col.num]
          com.watershed2[which(com.watershed1==target.watid)] <- mod.watid
        }
      }
      
      zz2 <- 1/t(apply( com.watershed2[(row+1):(2*row),],2,rev )) 
      
      #Watershed algorithm
      xx2 <- (1:nrow(zz2))/col*RTruntime+RTini
      yy2 <-(((1:ncol(zz2))/row*MPeriod))
      
      
      windows(width=10,height=5)
      par(mar=c(5,7,1,1))
      
      
      ###20200604
      zz2r <- replace(zz2,which(zz2==Inf),0)
      max.zz <- max(zz2r)
      min.zz <- min(zz2r)
      
      filled.contour(xx2,yy2,zz2r,xlab="GC1 (min)",ylab="GC2 (sec)",col=terrain.colors(30),levels=seq(0,max.zz/100+exp(-100),max.zz/100/30+exp(-100)) )
      ###20200604
      
      
      #Extract peaktop
      zz3.pre <- t(apply(com.watershed2[(row+1):(2*row),],2,rev))
      zz3 <- apply(apply(zz3.pre,1,rev),2,rev)
      zz1 <- t(zz1) 
      
      original.mat <- matrix(1:(row*col),row,col)
      LocalMax.point <- 0
      row.correspond.point <- 0
      col.correspond.point <- 0
      peak.volume <- 0
      for (watershed.id in sort(unique(as.numeric(zz3[zz3>0]))) ){
        focus.watershed <- which(zz3 == watershed.id)
        peak.volume.pre <- sum( zz1[focus.watershed] )
        LocalMax.point.pre <- focus.watershed[which( zz1[focus.watershed]==max(zz1[focus.watershed]) )[1]]
        LocalMax.point <- rbind(LocalMax.point,LocalMax.point.pre)
        correspond.point <- which(original.mat==LocalMax.point.pre[1])
        row.correspond.point.pre <-which(original.mat==correspond.point, arr.ind=TRUE)[1]
        col.correspond.point.pre <-which(original.mat==correspond.point, arr.ind=TRUE)[2]
        row.correspond.point <- rbind(row.correspond.point,row.correspond.point.pre)
        col.correspond.point <- rbind(col.correspond.point,col.correspond.point.pre)
        peak.volume <- rbind(peak.volume, peak.volume.pre)
      }
      
      LocalMax.point <- LocalMax.point[-c(1)] -1
      
      if ( any(LocalMax.point==0) ){
        for (iLocal in 1:length(which(LocalMax.point==0)) ){
          LocalMax.point[which(LocalMax.point==0)][iLocal] <- max(LocalMax.point) + iLocal
        }
      }
      
      peak.volume <- peak.volume[-c(1)]
      LocalMax.point[which(LocalMax.point >= length(MSintbox[,1]))] <- 1
      peak.volume[which(LocalMax.point >= length(MSintbox[,1]))] <- 0
      col.correspond.point <- col.correspond.point[-c(1)]
      row.correspond.point <- row.correspond.point[-c(1)]
      col.correspond.point[which(LocalMax.point >= length(MSintbox[,1]))] <- 0
      row.correspond.point[which(LocalMax.point >= length(MSintbox[,1]))] <- 0
      
      point.RT1 <- (col.correspond.point-1) * MPeriod /60 + RTini
      point.RT2 <- (row.correspond.point-3) * (1/SamRate)
      
      if ( any(point.RT2<0) ){
        point.RT2[which(point.RT2<0) ] <- point.RT2[which(point.RT2<0) ] + MPeriod 
      }
      
      peak.value <- zz1[LocalMax.point]
      
      if( sum(point.RT1)>0 & sum(point.RT2)>0 ){ #20200604
        No.peak.flag <- "Yes.Peaks" #20200604
        
        point.RT1.matrix <- matrix(0,length(point.RT1)*2,1)
        point.RT1.matrix[seq(1,length(point.RT1.matrix),2),1] <- point.RT1 
        point.RT2.matrix <- matrix(0,length(point.RT2)*2,1)
        point.RT2.matrix[seq(1,length(point.RT2.matrix),2),1] <- point.RT2 
        peak.value.matrix <- matrix(0,length(peak.value)*2,1)
        peak.value.matrix[seq(1,length(peak.value.matrix),2),1] <- peak.value 
        peak.volume.matrix <- matrix(0,length(peak.volume)*2,1)
        peak.volume.matrix[seq(1,length(peak.volume.matrix),2),1] <- peak.volume
        
        csv.tempncol <- ncol(MSvaluebox)/2
        
        LocalMax.MSintbox <- MSintbox[LocalMax.point,]
        LocalMax.MSvaluebox <- MSvaluebox[LocalMax.point,]
        
        notzerorow <- 1:length(LocalMax.MSvaluebox[,1]) 
        csv.tempsave <- matrix(NA,2*length(notzerorow),csv.tempncol )
        
        for ( apdi in 1:length(notzerorow) ){
          extpeakMSvalue.extzero <- LocalMax.MSvaluebox[apdi,-c(which(LocalMax.MSintbox[apdi,]==0))]
          extpeakMSint.extzero <- LocalMax.MSintbox[apdi,-c(which(LocalMax.MSintbox[apdi,]==0))]
          if (sum(extpeakMSvalue.extzero) > 0){
            sorted.extpeakMSint.relative <- sort(extpeakMSint.extzero / sum(extpeakMSint.extzero) *100,decreasing =T)
            sorted.extpeakMSvalue <- extpeakMSvalue.extzero[order(extpeakMSint.extzero,decreasing=T)]
            rid <- 2*apdi-1
            csv.tempsave[rid,1:csv.tempncol] <- sorted.extpeakMSvalue[1:csv.tempncol] 
            csv.tempsave[rid+1,1:csv.tempncol] <- sorted.extpeakMSint.relative[1:csv.tempncol]
          } else {
            rid <- 2*apdi-1
            csv.tempsave[rid,1:csv.tempncol] <- 0 
            csv.tempsave[rid+1,1:csv.tempncol] <- 0
          }
        }
        
        
        twoD.RT <- cbind(point.RT1.matrix,point.RT2.matrix,peak.value.matrix,peak.volume.matrix,file.num, csv.tempsave)
        
        count.del.i <- 0
        ###20170303
        for (del.i in 1:nrow(twoD.RT) ){
          if ( sum(twoD.RT[del.i,5:10])==0 | is.na(sum(twoD.RT[del.i,5:10])) ){ #20200604
            count.del.i <- cbind(count.del.i, del.i)
          }
        }
        count.del.i <- count.del.i[-c(1)]
        
        if ( sum(count.del.i)!=0 ){
          twoD.RT <- twoD.RT[-c(count.del.i),]
        }
        
        fname <- paste("data.filename",file.num,sep="")
        write.csv(twoD.RT, paste("MSpeaklist_",savefilename,"_layer",file.num,".csv",sep="") )
        
        odd.count.del.i <-count.del.i[which(count.del.i %% 2 == 0)]/2
        delrow.notzerorow <- match(odd.count.del.i,notzerorow)
        if ( sum(delrow.notzerorow)!=0 ){
          notzerorow.forNIST <- notzerorow[-c(delrow.notzerorow)]
        } else {
          notzerorow.forNIST <- notzerorow
        }
        twoD.RTforMSvector <- twoD.RT[,5:ncol(twoD.RT)] #new20170303
        twoD.RTforMSvector[which(is.na(twoD.RTforMSvector))] <-0 #new20170303
        ###20170303
        
        
        NISTbox.apd <- matrix(0,1,2)
        inter.count <- 0
        for ( i in 1:length(notzerorow.forNIST) ){ #notzerorow > notzerorow.forNIST
          inter.count <- inter.count + 1
          if ( sum(which(twoD.RTforMSvector[2*i,]==0))!=0 ){ #new20170303
            extpeakMSvalue.extzero <- as.vector(twoD.RTforMSvector[2*i-1,-c(which(twoD.RTforMSvector[2*i-1,]==0))]) #new20170303
            extpeakMSint.extzero <- as.matrix(twoD.RTforMSvector[2*i,-c(which(twoD.RTforMSvector[2*i,]==0))]) #new20170303
          } else {
            extpeakMSvalue.extzero <- twoD.RTforMSvector[2*i-1,] #new20170303
            extpeakMSint.extzero <- twoD.RTforMSvector[2*i,] #new20170303
          }
          if(sum(extpeakMSvalue.extzero)==0) {extpeakMSvalue.extzero <-0}
          if(sum(extpeakMSint.extzero)==0) {extpeakMSint.extzero <-0}
          NISTbox <- matrix(0,length(extpeakMSvalue.extzero)+2,2)
          NISTbox[1,1] <- paste("name:Scan ",inter.count+cont.scan.i,sep="")
          NISTbox[2,1] <- paste("num:",length(extpeakMSvalue.extzero) ,sep="")
          NISTbox[3:(length(extpeakMSvalue.extzero)+2),1] <- round(extpeakMSvalue.extzero)
          NISTbox[3:(length(extpeakMSint.extzero)+2),2] <- round( extpeakMSint.extzero/ sum(extpeakMSint.extzero)*(10^5) ) #new 20170303
          
          
          if ( all(NISTbox[3:(length(extpeakMSvalue.extzero)+2),1]==-1) ){
            NISTbox[3:(length(extpeakMSvalue.extzero)+2),1] <- 0
            NISTbox[3:(length(extpeakMSint.extzero)+2),2] <- 0
            NISTbox <- NISTbox[-c(4:(length(extpeakMSvalue.extzero)+2)),]
            NISTbox[2,1] <- paste("num:",length(1) ,sep="")
          }
          
          
          NISTbox.apd <- rbind(NISTbox.apd,NISTbox)
        }
        NISTbox.apd <- NISTbox.apd[-c(1),]
        
        fname <- paste("data.filename",file.num,sep="")
        write.table(NISTbox.apd,paste("MSpeaklist_forNISTsearch_",savefilename,"_layer",file.num,".txt",sep=""),sep="\t",quote=F,row.names=F,col.names=F)
        
        cont.scan.i <- i + cont.scan.i
        
      } else { #20200604
        No.peak.flag <- "No.peak" #20200604
        message(paste("No peak available in layer " ,file.num, sep="") ) #20200604
      } #if( sum(point.RT1)>0 & sum(point.RT2)>0 ){ #20200604
      
    }
    
    if ( No.peak.flag != "No.peak" ){ #20200604
      #Combine files
      for (r.fname2 in 0:deconv.num){
        fname2 <- paste("RTdeconv",r.fname2,sep="")
        fname.paste2 <- paste("read.csv('MSpeaklist_",savefilename, "_layer",r.fname2, ".csv',header=T)",sep="")
        eval(parse(text=paste(fname2, "<-", fname.paste2,sep="") ))
        fname3 <- paste("forNISTsearch",r.fname2,sep="")
        fname.paste3 <- paste("read.table('MSpeaklist_forNISTsearch_", savefilename,"_layer",r.fname2,".txt',header=F,sep='\t')",sep="")
        eval(parse(text=paste(fname3, "<-", fname.paste3,sep="") ))
      }
      
      bind.file <- paste(paste("RTdeconv",0:deconv.num,sep=""),collapse=",")
      eval(parse(text=paste("Combined_RTdeconv <- rbind(",bind.file,")",sep="" ) ))
      bind.file2 <- paste(paste("forNISTsearch",0:deconv.num,sep=""),collapse=",")
      eval(parse(text=paste("Combined_forNISTsearch <- rbind(",bind.file2,")",sep="" ) ))
      
      write.csv(Combined_RTdeconv,paste("Combined_MSpeaklist_", savefilename, ".csv",sep="") )
      write.table(Combined_forNISTsearch,paste("Combined_MSpeaklist_forNISTsearch_", savefilename, ".txt",sep=""),sep="\t",quote=F,row.names=F,col.names=F )
      
    } else { #20200604
      message("No peak available. Peak list files were not generated.") #20200604
    } #20200604
    
  }




