FinalDBcreate <-
  function(
    pos = pos,
    pos1 = pos1,
    savefilename = savefilename,
    MFthreshold = MFthreshold,
    hitnum = hitnum,
    Ext.word = Ext.word,
    GC1tol = GC1tol,
    GC2tol = GC2tol,
    MPeriod = MPeriod
  )
  {
    fromNISTfilename <- pos
    RTfilename <- pos1
    
    order.object <- "Library.Match.Factor"
    
    output.append <- as.data.frame( matrix(0,1,14) )
    csv.export.append <- matrix(0,1,10000)
    colnames(output.append) <- c("ID_BefRemDup","Compound.Name","Peak.I..min.","Peak.II..sec.","Peak.Value","Volume","Library.Match.Factor",
                                 "Library.Reverse.Match.Factor", "Library.Probability","Library.Formula","Library.CAS.","Library.ID","Library.Name","deconv.num")
    
    NISTres <- read.csv(fromNISTfilename,header=F,sep=";",quote="")
    
    NISTresbef <-substr(NISTres[,1],1,7)
    NISTresafe <-substr(NISTres[,1],9,100000)
    
    for (i in 1:5 ){
      NISTresafe <- sub(":",".",NISTresafe)
    }
    
    NISTresafe <- sub(" ",".",NISTresafe)
    NISTresapp <- paste(NISTresbef, NISTresafe,sep=":")
    NISTresafe2 <-sub(" ",".",NISTres[,2])
    NISTresapp2 <- paste(NISTresapp, NISTresafe2,sep=",")
    NISTresapp2 <- sub(",<<",":",NISTresapp2)
    
    NISTresappfin <- cbind(NISTresapp2,NISTres[,3:length(NISTres[1,])])
    NISTres <- NISTresappfin
    
    write.table(NISTres, "NISTres2.txt",sep=":",quote=FALSE,col.names=F,row.names = F)
    NISTres2 <- read.csv("NISTres2.txt",header=F,sep=":",quote="") 
    file.remove("NISTres2.txt")
    
    write.table(NISTres2, "NISTres2.txt",sep=":",quote=FALSE,col.names=F,row.names = F)
    NISTres2 <- read.csv("NISTres2.txt",header=F,sep=":",quote="")
    file.remove("NISTres2.txt")
    
    if (NISTres2[1,1]!="Unknown"){
      unknownbind <- NISTres2[which(NISTres2=="Unknown")[1],]
      NISTres2 <- rbind(unknownbind,NISTres2)
    }
    
    NISTres2 <- cbind(1:nrow(NISTres2),NISTres2)
    rownames(NISTres2) <-2:(nrow(NISTres2)+1)
    
    colnames(NISTres2) <- c("ID","HitID","Compound name","formula","MFh5","MF","RMFh7","RMF","Probh9","Prob","CASh11","CAS","Mwh13","Mw","Libh15","Lib","LibIDh17","LibID" )
    NISTres2 <- NISTres2[,-c(5,7,9,11,13,15,17)]
    
    NISTres2 <- as.matrix(NISTres2)
    hitcount <- length(which(NISTres2[,2]=="Unknown"))
    
    NISTres2[,4] <-substr(NISTres2[,4],1,nchar(NISTres2[,4])-2 )
    linenum <- 1:length(NISTres2[,1])
    
    linenum <- linenum[-c(seq(1,length(NISTres2[,1]),hitcount ))]
    NISTres2[linenum,c(3,10)] <- substr(NISTres2[linenum,c(3,10)],4,nchar(NISTres2[linenum,c(3,10)])-2 )
    
    NISTres2 <- sub("<<","",NISTres2)
    
    
    simseq <- 1:length(NISTres2[,1])
    remseq <- as.numeric ( which(NISTres2[,2]=="Hit 1  ") )
    finseq <- simseq[-c(remseq)]
    
    if ( max(remseq) > max(simseq) ) {
      NISTres2new <- as.matrix(NISTres2[-c(finseq[1:(length(finseq)-1)]),])
    } else {
      NISTres2new <- as.matrix(NISTres2[-c(finseq),])
    }
    if ( length(remseq)==1 ){
      NISTres2new <- t(as.matrix(NISTres2[-c(finseq),]))
    }
    
    NISTres2new[,10] <- sub(">>","",NISTres2new[,10])
    NISTres2new[,10] <- sub(" ","",NISTres2new[,10])
    
    listnum <- which(as.numeric(NISTres2new[,5]) >= MFthreshold)
    
    remseq2 <- as.numeric ( names(which(NISTres2[,2]=="Unknown")) )
    if ( max(remseq2) > max(simseq) ) {
      remseq2 <- remseq2[ 1:(length(remseq2)-1) ]
    }
    listnum2 <- which(as.numeric(NISTres2[remseq2,5]) >= MFthreshold)
    
    ExtractedNISTres <- NISTres2new[listnum,]
    
    RTlist <- read.csv(RTfilename,header=T)
    ExtractedRT <- RTlist[2*(listnum2)-1,]
    ExtractedRTboth <- RTlist[sort(c(2*(listnum2)-1,2*(listnum2))),]
    ExtractedRT[,c(3,4)] <- round(ExtractedRT[,c(3,4)],digits=3)
    
    if ( nrow(ExtractedRT) > 0 ){
      
      ###20200604
      if( nrow(ExtractedRT)==1 ){
        ExtractedRT <- rbind(ExtractedRT,ExtractedRT)
        ExtractedNISTres <- rbind(ExtractedNISTres,ExtractedNISTres)
        output.onefile <- cbind( seq(1:length(ExtractedRT[,1])),ExtractedNISTres[,c(3)],ExtractedRT[,c(3:6)],ExtractedNISTres[,c(5:7,4,8,11,10)],ExtractedRT[7] )
        colnames(output.onefile) <- c("ID_BefRemDup","Compound.Name","Peak.I..min.","Peak.II..sec.","Peak.Value","Volume","Library.Match.Factor",
                                      "Library.Reverse.Match.Factor", "Library.Probability","Library.Formula","Library.CAS.","Library.ID","Library.Name","deconv.num")
        output.onefile <- output.onefile[1,]
        
      } else {
        output.onefile <- cbind( seq(1:length(ExtractedRT[,1])),ExtractedNISTres[,c(3)],ExtractedRT[,c(3:6)],ExtractedNISTres[,c(5:7,4,8,11,10)],ExtractedRT[7] )
        colnames(output.onefile) <- c("ID_BefRemDup","Compound.Name","Peak.I..min.","Peak.II..sec.","Peak.Value","Volume","Library.Match.Factor",
                                      "Library.Reverse.Match.Factor", "Library.Probability","Library.Formula","Library.CAS.","Library.ID","Library.Name","deconv.num")
      }
      ###20200604      
      
      
      
      if ( sum(listnum) == 0 ){
        csv.export.append <- csv.export.append
      } else{
        csv.export <- matrix(NA,2*length(listnum),16 + ncol(RTlist)-8+1 )
        for ( apdi in 1:length(listnum) ){
          rid <- 2*apdi-1
          csv.export[rid,1] <- apdi
          csv.export[rid,2] <- ExtractedNISTres[apdi,3]
          csv.export[rid,4] <- 0
          csv.export[rid,5] <- 0
          csv.export[rid,6] <- ExtractedRTboth[rid,3]
          csv.export[rid,7] <- ExtractedRTboth[rid,4]
          csv.export[rid,8] <- 0
          csv.export[rid,9] <- ExtractedNISTres[apdi,4]
          csv.export[rid,10] <- ExtractedNISTres[apdi,5]
          csv.export[rid,11] <- ExtractedNISTres[apdi,6]
          csv.export[rid,12] <- ExtractedNISTres[apdi,8]
          csv.export[rid,13] <- ExtractedNISTres[apdi,11]
          csv.export[rid,14] <- ExtractedNISTres[apdi,10]
          csv.export[rid,15] <- "fileNumber"
          csv.export[rid,16] <- ExtractedRTboth[rid,7]
          csv.export[rid,(17:ncol(csv.export))] <- as.numeric(ExtractedRTboth[rid,8:(ncol(ExtractedRTboth) )])
          csv.export[rid+1,(17:ncol(csv.export))] <- as.numeric(ExtractedRTboth[rid+1,8:(ncol(ExtractedRTboth) )])
        }
        dimnames(csv.export) <- list(c(1:(2*length(listnum))),c("BlobID","Compound Abriviation","Group Name","Rtcorrect","Internal Standard","Peak I (min)","Peak II (sec)","IS_Native_ref","q","MF","RMF","CAS","LibID","Lib","file.number","deconv.number",paste("MS",seq(1,(ncol(ExtractedRTboth)-8+1 ),1),sep="") ))
        
        csv.export.append <- csv.export.append[,1:ncol(csv.export)]
        csv.export.append <- rbind(csv.export.append,csv.export)
      }
      output.append <- rbind(output.append,output.onefile)
      
      
      if (output.append[1,1]==0 & nrow(output.append)>1 ){
        output.append <- output.append[-c(1),]
        csv.export.append <- csv.export.append[-c(1),]
      }
      
      
      Ext.row <- grep(Ext.word, as.matrix(output.append$Library.Formula) )
      output.append <- output.append[Ext.row,]
      csv.export.append <- csv.export.append[sort(c(2*Ext.row-1,2*Ext.row)),]
      
      order.number <- order( eval(parse(text=paste("output.append$",order.object,sep="") )),decreasing=T)
      output.append <- output.append[order.number,]
      
      memorize <- 0
      notNA <- as.numeric(which(output.append$Library.CAS.!="0-00-0"))
      if ( length(notNA)>0 ){
        windows(width=4,height=1)
        par(mar=c(0,0,0,0))
        plot(0:1,0:1,type="n",axes=F,ann=F)
        
        for (checkdup in notNA){	
          segments(0.08,0.6,0.92,0.6,lwd=70, col="white")
          text(0.4,0.8,paste("Duplication check...",checkdup))
          rect(0,0.1,1,0.1,lwd=2)
          segments(0,0.1,which(notNA==checkdup)/length(notNA),0.1,col="red",lwd=4)
          dupnum <- c(1:length(output.append[,1]))[which(output.append$Library.CAS.[checkdup] ==  output.append$Library.CAS.)]
          
          if (length(dupnum) >1){
            dupnum <- dupnum[-c(which(dupnum <= checkdup))]
            
            for (eachcheck2 in dupnum ){
              dif.2.sec <- abs( (as.numeric(output.append$Peak.II..sec.[checkdup])- as.numeric(output.append$Peak.II..sec.[eachcheck2]) ) )
              if (dif.2.sec >= MPeriod-GC2tol){
                dif.2.sec <- abs(dif.2.sec-MPeriod) 
              }
              if( abs( (as.numeric(output.append$Peak.I..min.[checkdup])- as.numeric(output.append$Peak.I..min.[eachcheck2])) ) < GC1tol & dif.2.sec  < GC2tol ){
                memorize <- rbind(memorize,eachcheck2)
              }
            }
          }
        }
        dev.off()
      }
      
      
      if (length(memorize) > 1 ){ 
        memorize <- memorize[-c(1)]
        delete.row.fortesen <- output.append[memorize,1] 
        delete.row.1 <- match(2*delete.row.fortesen-1, as.numeric(rownames(csv.export.append)) )
        output.append <- output.append[-c(memorize),]
        csv.export.append <- csv.export.append[-c(delete.row.1,delete.row.1+1),]
      }
      
      memorize <- 0
      caseNA <- c(1:length(output.append[,1]))[which("0-00-0" ==  output.append$Library.CAS.)]
      if ( length(caseNA)>0 ){
        dupnum <- c(1:length(output.append[,1]))[which("0-00-0" ==  output.append$Library.CAS.)]
        if (length(dupnum) >1){
          windows(width=4,height=1)
          par(mar=c(0,0,0,0))
          plot(0:1,0:1,type="n",axes=F,ann=F)
          for (eachcheck in 1:length(caseNA) ){
            segments(0.08,0.6,0.92,0.6,lwd=70, col="white")
            text(0.4,0.8,paste("0-00-0 check...",eachcheck))
            rect(0,0.1,1,0.1,lwd=2)
            segments(0,0.1,which(1:(length(caseNA))==eachcheck)/(length(caseNA)),0.1,col="red",lwd=4)
            
            
            dupnum <- which(output.append$Compound.Name[caseNA[eachcheck]]==output.append$Compound.Name )
            dupnum <- dupnum[-c(which(dupnum <= caseNA[eachcheck] ))]	
            memo.num <- caseNA[eachcheck]
            
            for (eachcheck2 in dupnum ){
              dif.2.sec <- abs( (as.numeric(output.append$Peak.II..sec.[memo.num])- as.numeric(output.append$Peak.II..sec.[eachcheck2]) ) )
              if (dif.2.sec >= MPeriod-GC2tol){
                dif.2.sec <- abs(dif.2.sec-MPeriod)
              }
              if( abs( (as.numeric(output.append$Peak.I..min.[memo.num])- as.numeric(output.append$Peak.I..min.[eachcheck2])) ) < GC1tol & dif.2.sec  < GC2tol ){
                memorize <- rbind(memorize,eachcheck2)
              }
            }
          }
          dev.off()
        }
        
      }
      
      if (length(memorize) > 1 ){ 
        memorize <- memorize[-c(1)]
        delete.row.fortesen <- output.append[memorize,1] 
        delete.row.1 <- match(2*delete.row.fortesen-1, as.numeric(rownames(csv.export.append)) )
        output.append <- output.append[-c(memorize),]
        csv.export.append <- csv.export.append[-c(delete.row.1,delete.row.1+1),]
      }
      re.order.number <- order( output.append[,1])
      output.append <- output.append[re.order.number,]
      
      delrow <- 0
      
      if ( nrow(csv.export.append) >0 ){
        for (k in seq(1,nrow(csv.export.append),2) ){
          if ( all(csv.export.append[k,(17:ncol(csv.export.append))]==0) ){
            delrow <- c(delrow,k,k+1)
          }
        }
        
        if ( sum(delrow)!=0 ){
          delrow <- delrow[-c(1)]
          csv.export.append <- csv.export.append[-delrow,]
        }
        
        
        input.file <- output.append
        tsen.file <- csv.export.append
        
        Ext.row <- grep(Ext.word, as.matrix(input.file$Library.Formula) )
        
        if ( Ext.word!="" ){
          input.file <- input.file[Ext.row,]
          tsen.file <- tsen.file[sort(c(2*Ext.row-1,2*Ext.row)),]
        }
        
        order.number <- order( eval(parse(text=paste("input.file$",order.object,sep="") )),decreasing=T)
        input.file <- input.file[order.number,]
        
        
        
        
        memorize <- 0
        notNA <- as.numeric(which(input.file$Library.CAS.!="0-00-0"))
        if ( length(notNA)>0 ){
          windows(width=4,height=1)
          par(mar=c(0,0,0,0))
          plot(0:1,0:1,type="n",axes=F,ann=F)
          
          for (checkdup in notNA){	
            segments(0.08,0.6,0.92,0.6,lwd=70, col="white")
            text(0.4,0.8,paste("Duplication check...",checkdup))
            rect(0,0.1,1,0.1,lwd=2)
            segments(0,0.1,which(notNA==checkdup)/length(notNA),0.1,col="red",lwd=4)
            dupnum <- c(1:length(input.file[,1]))[which(input.file$Library.CAS.[checkdup] ==  input.file$Library.CAS.)]
            
            if (length(dupnum) >1){
              dupnum <- dupnum[-c(which(dupnum <= checkdup))]
              for (eachcheck2 in dupnum ){
                dif.2.sec <- abs( (as.numeric(input.file$Peak.II..sec.[checkdup])- as.numeric(input.file$Peak.II..sec.[eachcheck2]) ) )
                if (dif.2.sec >= MPeriod-GC2tol){
                  dif.2.sec <- abs(dif.2.sec-MPeriod) 
                }
                if( abs( (as.numeric(input.file$Peak.I..min.[checkdup])- as.numeric(input.file$Peak.I..min.[eachcheck2])) ) < GC1tol & dif.2.sec  < GC2tol ){
                  memorize <- rbind(memorize,eachcheck2)
                }
              }
            }
          }
          dev.off()
        }
        
        if (length(memorize) > 1 ){ 
          memorize <- memorize[-c(1)]
          delete.row.fortesen <- input.file[memorize,1] 
          delete.row.1 <- match(2*delete.row.fortesen-1, as.numeric(rownames(csv.export.append)) )
          input.file <- input.file[-c(memorize),]
          tsen.file <- tsen.file[-c(delete.row.1,delete.row.1+1),]
        }
        
        memorize <- 0
        caseNA <- c(1:length(input.file[,1]))[which("0-00-0" ==  input.file$Library.CAS.)]
        if ( length(caseNA)>0 ){
          dupnum <- c(1:length(input.file[,1]))[which("0-00-0" ==  input.file$Library.CAS.)]
          if (length(dupnum) >1){
            
            windows(width=4,height=1)
            par(mar=c(0,0,0,0))
            plot(0:1,0:1,type="n",axes=F,ann=F)
            for (eachcheck in 1:length(caseNA) ){
              segments(0.08,0.6,0.92,0.6,lwd=70, col="white")
              text(0.4,0.8,paste("0-00-0 check...",eachcheck))
              rect(0,0.1,1,0.1,lwd=2)
              segments(0,0.1,which(1:(length(caseNA))==eachcheck)/(length(caseNA)),0.1,col="red",lwd=4)
              dupnum <- which(input.file$Compound.Name[caseNA[eachcheck]]==input.file$Compound.Name )
              dupnum <- dupnum[-c(which(dupnum <= caseNA[eachcheck] ))]	
              memo.num <- caseNA[eachcheck]
              for (eachcheck2 in dupnum ){
                dif.2.sec <- abs( (as.numeric(input.file$Peak.II..sec.[memo.num])- as.numeric(input.file$Peak.II..sec.[eachcheck2]) ) )
                if (dif.2.sec >= MPeriod-GC2tol){
                  dif.2.sec <- abs(dif.2.sec-MPeriod)
                }
                if( abs( (as.numeric(input.file$Peak.I..min.[memo.num])- as.numeric(input.file$Peak.I..min.[eachcheck2])) ) < GC1tol & dif.2.sec  < GC2tol ){
                  memorize <- rbind(memorize,eachcheck2)
                }
              }
            }
            dev.off()
          }
          
        }
        
        if (length(memorize) > 1 ){ 
          memorize <- memorize[-c(1)]
          delete.row.fortesen <- output.append[memorize,1] 
          delete.row.1 <- match(2*delete.row.fortesen-1, as.numeric(rownames(csv.export.append)) )
          input.file <- input.file[-c(memorize),]
          tsen.file <- tsen.file[-c(delete.row.1,delete.row.1+1),]
        }
        
        re.order.number <- order( input.file[,1])
        input.file <- input.file[re.order.number,]
        
        na.row.find <- tsen.file[,17:(17+5-1)]=="NA"
        exist.row <- which(rowSums(na.row.find)==0)
        na.row <- c(1:nrow(tsen.file))[-c(exist.row)]
        if ( sum(na.row)!=0 ){
          tsen.file <- tsen.file[-c(na.row),]
          na.row.odd <- ceiling(na.row[which(na.row%%2==1)]/2)
          input.file <- input.file[-c(na.row.odd),]
        }
        
        write.csv(input.file,paste("SimplePeaklist_condition",Ext.word,"_",savefilename,".csv",sep="") )
        write.csv(tsen.file,paste("Database_condition",Ext.word,"_",savefilename,".csv",sep="") )
        
        error.message <<- "No error"
        
      } else {
        
        error.message <<- "No candidate found"
        cat(error.message)
        
      }
      error.message <<- "No error"
      
      DBcheckInNIST(savefilename) #20200604
      cat("4DBfinalCheckInNIST.r was also completed.") #20200604
      cat(error.message) #20200604
      
    } else {
      error.message <<- "No candidate found"
      return(error.message)
      
      DBcheckInNIST(savefilename) #20200604
      cat("4DBfinalCheckInNIST.r was also completed.") #20200604
      cat(error.message) #20200604
      
    }
  }
