DBcheckInNIST <-
  function(
    savefilename = savefilename
  )
  {
    if (error.message != "No candidate found"){
      input.file.name <- paste("Database_condition",Ext.word,"_",savefilename,".csv",sep="")
      tsen.database <- read.csv(input.file.name,header=T)
      
      #20200604
      if( nrow(tsen.database)==0 ){
        message("No candidate found for the database construction")
      } else {
        #20200604
        
        tsen.database <- as.matrix(tsen.database)
        tsen.database <- replace(tsen.database,is.na(tsen.database),0)
        tsen.database <- tsen.database[,-c(1:17)]
        write.csv(tsen.database,"tempsave.csv",row.names=F)
        tsen.database <- read.csv("tempsave.csv",header=T)
        
        
        NISTbox.apd <- matrix(0,1,2)
        for ( i in seq(1,nrow(tsen.database),2) ){
          if ( sum(which(tsen.database[i+1,1:ncol(tsen.database)]==0))!=0 ){
            extpeakMSvalue.extzero <- as.numeric(tsen.database[i,-c(which(tsen.database[i+1,1:ncol(tsen.database)]==0))])
            extpeakMSint.extzero <- as.numeric(tsen.database[i+1,-c(which(tsen.database[i+1,1:ncol(tsen.database)]==0))])*10000
          } else {
            extpeakMSvalue.extzero <- as.numeric(tsen.database[i,])
            extpeakMSint.extzero <- as.numeric(tsen.database[i+1,])*10000
          }
          if(sum(extpeakMSvalue.extzero)==0) {
            extpeakMSvalue.extzero <-0
          }
          if(sum(extpeakMSint.extzero)==0) {
            extpeakMSint.extzero <-0
          }
          NISTbox <- matrix(0,length(extpeakMSvalue.extzero)+2,2)
          NISTbox[1,1] <- paste("name:Scan ",ceiling(i/2),sep="")
          NISTbox[2,1] <- paste("num:",length(extpeakMSvalue.extzero) ,sep="")
          NISTbox[3:(length(extpeakMSvalue.extzero)+2),1] <- as.numeric(round(extpeakMSvalue.extzero))
          NISTbox[3:(length(extpeakMSint.extzero)+2),2] <- as.numeric(round(extpeakMSint.extzero))
          
          if ( all(NISTbox[3:(length(extpeakMSvalue.extzero)+2),1]==-1) ){
            NISTbox[3:(length(extpeakMSvalue.extzero)+2),1] <- 0
            NISTbox[3:(length(extpeakMSint.extzero)+2),2] <- 0
            NISTbox <- NISTbox[-c(4:(length(extpeakMSvalue.extzero)+2)),]
            NISTbox[2,1] <- paste("num:",length(1) ,sep="")
          }
          
          
          NISTbox.apd <- rbind(NISTbox.apd,NISTbox)
        }
        NISTbox.apd <- NISTbox.apd[-c(1),]
        NISTbox.apd[which(NISTbox.apd<0)] <- 0
        
        write.table(NISTbox.apd,paste("FinalCheck_forNISTsearch",input.file.name,".txt",sep=""),sep="\t",quote=F,row.names=F,col.names=F)
        
      } #if( nrow(tsen.database)==0 ){ #20200604
      
    } else {
      return( "Error. It may indicate no candidate found" )
    }
  }
